import{s as se,n as de,o as ce}from"../chunks/scheduler.7da89386.js";import{S as le,i as ue,g as s,s as i,r as w,A as me,h as d,f as t,c as n,j as F,u as y,x as G,k as L,y as r,a as c,v as x,d as $,t as Q,w as B}from"../chunks/index.0b7befd3.js";import{D as j}from"../chunks/Docstring.b7b38e43.js";import{H as te}from"../chunks/Heading.8a936589.js";function pe(oe){let l,k,P,D,g,E,_,U,a,f,J,C,ae="Handles the Runtime quantization process for models shared on huggingface.co/models.",K,m,v,X,T,ie="Loads the BrevitasQuantizer and model.",Y,p,z,Z,O,ne="Quantizes the model using Brevitas according to the <code>quantization_config</code>.",H,q,W,u,b,ee,N,re="QuantizationConfig is the configuration class handling all the Brevitas quantization parameters.",S,I,A;return g=new te({props:{title:"Quantization Using Brevitas",local:"quantization-using-brevitas",headingTag:"h1"}}),_=new te({props:{title:"BrevitasQuantizer",local:"optimum.amd.BrevitasQuantizer",headingTag:"h2"}}),f=new j({props:{name:"class optimum.amd.BrevitasQuantizer",anchor:"optimum.amd.BrevitasQuantizer",parameters:[{name:"model",val:": Module"},{name:"model_name_or_path",val:": str"}],source:"https://github.com/huggingface/optimum.amd/blob/vr_149/optimum/amd/brevitas/quantizer.py#L27"}}),v=new j({props:{name:"from_pretrained",anchor:"optimum.amd.BrevitasQuantizer.from_pretrained",parameters:[{name:"model_name_or_path",val:": str"},{name:"subfolder",val:": str = ''"},{name:"revision",val:": Optional = None"},{name:"cache_dir",val:": Optional = None"},{name:"trust_remote_code",val:": bool = False"},{name:"force_download",val:": bool = False"},{name:"local_files_only",val:": bool = False"},{name:"use_auth_token",val:": Union = None"},{name:"device_map",val:": Union = None"},{name:"**model_kwargs",val:""}],parametersDescription:[{anchor:"optimum.amd.BrevitasQuantizer.from_pretrained.model_name_or_path",description:`<strong>model_name_or_path</strong> (<code>Union[str, Path]</code>) &#x2014;
Can be either the model id of a model repo on the Hugging Face Hub, or a path to a local directory
containing a model.`,name:"model_name_or_path"},{anchor:"optimum.amd.BrevitasQuantizer.from_pretrained.subfolder",description:`<strong>subfolder</strong> (<code>str</code>, defaults to <code>&quot;&quot;</code>) &#x2014;
In case the model files are located inside a subfolder of the model directory / repo on the Hugging
Face Hub, you can specify the subfolder name here.`,name:"subfolder"},{anchor:"optimum.amd.BrevitasQuantizer.from_pretrained.revision",description:`<strong>revision</strong> (<code>Optional[str]</code>, <em>optional</em>, defaults to <code>None</code>) &#x2014;
Revision is the specific model version to use. It can be a branch name, a tag name, or a commit id.`,name:"revision"},{anchor:"optimum.amd.BrevitasQuantizer.from_pretrained.cache_dir",description:`<strong>cache_dir</strong> (<code>Optional[str]</code>, <em>optional</em>) &#x2014;
Path to a directory in which a downloaded pretrained model weights have been cached if the standard cache should not be used.`,name:"cache_dir"},{anchor:"optimum.amd.BrevitasQuantizer.from_pretrained.trust_remote_code",description:`<strong>trust_remote_code</strong> (<code>bool</code>, defaults to <code>False</code>) &#x2014;
Allows to use custom code for the modeling hosted in the model repository. This option should only be set for repositories
you trust and in which you have read the code, as it will execute on your local machine arbitrary code present in the
model repository.`,name:"trust_remote_code"},{anchor:"optimum.amd.BrevitasQuantizer.from_pretrained.force_download",description:`<strong>force_download</strong> (<code>bool</code>, defaults to <code>False</code>) &#x2014;
Whether or not to force the (re-)download of the model weights and configuration files, overriding the
cached versions if they exist.`,name:"force_download"},{anchor:"optimum.amd.BrevitasQuantizer.from_pretrained.local_files_only",description:`<strong>local_files_only</strong> (<code>Optional[bool]</code>, defaults to <code>False</code>) &#x2014;
Whether or not to only look at local files (i.e., do not try to download the model).`,name:"local_files_only"},{anchor:"optimum.amd.BrevitasQuantizer.from_pretrained.use_auth_token",description:`<strong>use_auth_token</strong> (<code>Optional[str]</code>, defaults to <code>None</code>) &#x2014;
The token to use as HTTP bearer authorization for remote files. If <code>True</code>, will use the token generated
when running <code>transformers-cli login</code> (stored in <code>~/.huggingface</code>).`,name:"use_auth_token"}],source:"https://github.com/huggingface/optimum.amd/blob/vr_149/optimum/amd/brevitas/quantizer.py#L39"}}),z=new j({props:{name:"quantize",anchor:"optimum.amd.BrevitasQuantizer.quantize",parameters:[{name:"quantization_config",val:": BrevitasQuantizationConfig"},{name:"calibration_dataset",val:": Optional = None"}],parametersDescription:[{anchor:"optimum.amd.BrevitasQuantizer.quantize.quantization_config",description:`<strong>quantization_config</strong> (<code>BrevitasQuantizationConfig</code>) &#x2014;
Quantization configuration to use to quantize the model.`,name:"quantization_config"},{anchor:"optimum.amd.BrevitasQuantizer.quantize.calibration_dataset",description:`<strong>calibration_dataset</strong> (<code>Optional[List[Dict]]</code>, defaults to <code>None</code>) &#x2014;
In case the quantization involves a calibration phase, this argument needs to be specified as a list of inputs to the model.
Example: <code>calibration_dataset = [{&quot;input_ids&quot;: torch.tensor([[1, 2, 3, 4]])}, {&quot;input_ids&quot;: torch.tensor([[6, 7, 3, 4]])}]</code> which is a dataset for a model taking <code>input_ids</code> as an argument, and which has two samples.`,name:"calibration_dataset"}],source:"https://github.com/huggingface/optimum.amd/blob/vr_149/optimum/amd/brevitas/quantizer.py#L108"}}),q=new te({props:{title:"BrevitasQuantizationConfig",local:"optimum.amd.BrevitasQuantizationConfig",headingTag:"h2"}}),b=new j({props:{name:"class optimum.amd.BrevitasQuantizationConfig",anchor:"optimum.amd.BrevitasQuantizationConfig",parameters:[{name:"weights_bitwidth",val:": int = 8"},{name:"activations_bitwidth",val:": Optional = 8"},{name:"weights_only",val:": bool = False"},{name:"weights_param_method",val:": Literal = 'stats'"},{name:"weights_symmetric",val:": bool = True"},{name:"scale_precision",val:": Literal = 'float_scale'"},{name:"weights_quant_granularity",val:": Literal = 'per_tensor'"},{name:"weights_group_size",val:": Optional = None"},{name:"quantize_zero_point",val:": bool = True"},{name:"activations_param_method",val:": Optional = 'stats'"},{name:"is_static",val:": bool = False"},{name:"activations_symmetric",val:": Optional = False"},{name:"activations_quant_granularity",val:": Optional = 'per_tensor'"},{name:"activations_group_size",val:": Optional = None"},{name:"activations_equalization",val:": Optional = 'cross_layer'"},{name:"apply_weight_equalization",val:": bool = False"},{name:"apply_bias_correction",val:": bool = False"},{name:"apply_gptq",val:": bool = False"},{name:"gptq_act_order",val:": Optional = None"},{name:"device",val:": str = 'auto'"},{name:"layers_to_exclude",val:": Optional = None"},{name:"gpu_device_map",val:": Optional = None"},{name:"cpu_device_map",val:": Optional = None"}],parametersDescription:[{anchor:"optimum.amd.BrevitasQuantizationConfig.weights_bitwidth",description:`<strong>weights_bitwidth</strong> (<code>int</code>, defaults to <code>8</code>) &#x2014;
Bitwidth of the weights quantization. For example, with <code>weights_bitwidth=8</code>, each weight value is quantized on 8 bits.`,name:"weights_bitwidth"},{anchor:"optimum.amd.BrevitasQuantizationConfig.activations_bitwidth",description:`<strong>activations_bitwidth</strong> (<code>Optional[int]</code>, defaults to <code>8</code>) &#x2014;
Bitwidth of the activations quantization.`,name:"activations_bitwidth"},{anchor:"optimum.amd.BrevitasQuantizationConfig.weights_only",description:`<strong>weights_only</strong> (<code>bool</code>, defaults to <code>False</code>) &#x2014;
If set to <code>True</code>, only weights are to be quantized, otherwise activations are quantized as well.`,name:"weights_only"},{anchor:"optimum.amd.BrevitasQuantizationConfig.weights_param_method",description:`<strong>weights_param_method</strong> (<code>str</code>, defaults to <code>stats</code>) &#x2014;
Strategy to use to estimate the quantization parameters (scale, zero-point) for the weights. Two strategies are available:<ul>
<li><code>&quot;stats&quot;</code>: Use min-max to estimate the range to quantize on.</li>
<li><code>&quot;mse&quot;</code>: Use mean-square error between the unquantized weights and quantized weights to estimate the range to quantize on.</li>
</ul>`,name:"weights_param_method"},{anchor:"optimum.amd.BrevitasQuantizationConfig.weights_symmetric",description:`<strong>weights_symmetric</strong> (<code>bool</code>, defaults to <code>True</code>) &#x2014;
Whether to use symmetric quantization on the weights.`,name:"weights_symmetric"},{anchor:"optimum.amd.BrevitasQuantizationConfig.scale_precision",description:`<strong>scale_precision</strong> (<code>str</code>, defaults to <code>&quot;float_scale&quot;</code>) &#x2014;
Precise the constraints on the scale. Can either be <code>&quot;float_scale&quot;</code> (arbitrary scales), or <code>&quot;power_of_two_scale&quot;</code> (scales constrainted to be a power of 2).`,name:"scale_precision"},{anchor:"optimum.amd.BrevitasQuantizationConfig.weights_quant_granularity",description:`<strong>weights_quant_granularity</strong> (<code>str</code>, defaults to <code>&quot;per_tensor&quot;</code>) &#x2014;
The granularity of the quantization of the weights. This parameter can either be:<ul>
<li><code>&quot;per_tensor&quot;</code>: A single scale (and possibly zero-point) is used for one weight matrix.</li>
<li><code>&quot;per_channel&quot;</code>: Each column (outer dimension) of the weight matrix has its own scale (and possibly zero-point).</li>
<li><code>&quot;per_group&quot;</code>: Each column of the weight matrix may have several scales, grouped by <code>weight_group_size</code>.</li>
</ul>`,name:"weights_quant_granularity"},{anchor:"optimum.amd.BrevitasQuantizationConfig.weights_group_size",description:`<strong>weights_group_size</strong> (<code>Optional[int]</code>, defaults to <code>None</code>) &#x2014;
Group size to use for the weights in case <code>weights_quant_granularity=&quot;per_group&quot;</code>. Defaults to <code>128</code> in this case, to <code>None</code> otherwise.`,name:"weights_group_size"},{anchor:"optimum.amd.BrevitasQuantizationConfig.quantize_zero_point",description:`<strong>quantize_zero_point</strong> (<code>bool</code>, defaults to <code>True</code>) &#x2014;
When set to True, the unquantized value 0.0 is exactly representable as a quantized value: the zero point. When set to False, a quantization range [a, b] is exactly reprensentable (no rounding on a and b), but the unquantized value zero is not exactly representable.`,name:"quantize_zero_point"},{anchor:"optimum.amd.BrevitasQuantizationConfig.activations_param_method",description:`<strong>activations_param_method</strong> (<code>List[str]</code>) &#x2014;
Strategy to use to estimate the quantization parameters (scale, zero-point) for the activations. Two strategies are available:<ul>
<li><code>&quot;stats&quot;</code>: Use min-max to estimate the range to quantize on.</li>
<li><code>&quot;mse&quot;</code>: Use mean-square error between the unquantized activations and quantized activations to estimate the range to quantize on.</li>
</ul>`,name:"activations_param_method"},{anchor:"optimum.amd.BrevitasQuantizationConfig.is_static",description:`<strong>is_static</strong> (<code>bool</code>, defaults to <code>False</code>) &#x2014;
Whether to apply static quantization or dynamic quantization.`,name:"is_static"},{anchor:"optimum.amd.BrevitasQuantizationConfig.activations_symmetric",description:`<strong>activations_symmetric</strong> (<code>bool</code>, defaults to <code>False</code>) &#x2014;
Whether to use symmetric quantization on the activations.`,name:"activations_symmetric"},{anchor:"optimum.amd.BrevitasQuantizationConfig.activations_quant_granularity",description:`<strong>activations_quant_granularity</strong> (<code>str</code>, defaults to <code>&quot;per_tensor&quot;</code>) &#x2014;
The granularity of the quantization of the activations. This parameter can either be <code>&quot;per_tensor&quot;</code>, <code>&quot;per_row&quot;</code> or <code>&quot;per_group&quot;</code>. In case static quantization is used (<code>is_static=True</code>), only <code>&quot;per_tensor&quot;</code> may be used.`,name:"activations_quant_granularity"},{anchor:"optimum.amd.BrevitasQuantizationConfig.activations_group_size",description:`<strong>activations_group_size</strong> (<code>int</code>, defaults to <code>None</code>) &#x2014;
Group size to use for the activations in case <code>activations_quant_granularity=&quot;per_group&quot;</code>. Defaults to <code>64</code> in this case, to <code>None</code> otherwise.`,name:"activations_group_size"},{anchor:"optimum.amd.BrevitasQuantizationConfig.activations_equalization",description:`<strong>activations_equalization</strong> (<code>Optional[str]</code>, defaults to <code>&quot;cross_layer&quot;</code>) &#x2014;
Whether to apply activation equalization (SmoothQuant). Possible options are:<ul>
<li><code>None</code>: No activation equalization.</li>
<li><code>&quot;layerwise&quot;</code>: Apply SmoothQuant as described in <a href="https://arxiv.org/abs/2211.10438" rel="nofollow">https://arxiv.org/abs/2211.10438</a>. The activation rescaling will be added as multiplication node, that is not fused within a preceding layer.</li>
<li><code>&quot;cross_layer&quot;</code>: Apply SmoothQuant, and fuse the activation rescaling within a preceding layer when possible (example: nn.LayerNorm followed by nn.Linear). This is achieved through a graph capture of the model using <a href="https://pytorch.org/docs/stable/fx.html#module-torch.fx" rel="nofollow">torch.fx</a>.</li>
</ul>`,name:"activations_equalization"},{anchor:"optimum.amd.BrevitasQuantizationConfig.apply_weight_equalization",description:`<strong>apply_weight_equalization</strong> (<code>bool</code>, defaults to <code>False</code>) &#x2014;
Applies weight equalization across layers, following <a href="https://arxiv.org/abs/1906.04721" rel="nofollow">https://arxiv.org/abs/1906.04721</a>. This parameter is useful for models whose activation function is linear or piecewise-linear (like ReLU, used in OPT model), and allows to reduce the quantization error of the weights by balancing scales across layers.`,name:"apply_weight_equalization"},{anchor:"optimum.amd.BrevitasQuantizationConfig.apply_bias_correction",description:`<strong>apply_bias_correction</strong> (<code>bool</code>, defaults to <code>False</code>) &#x2014;
Applies bias correction to compensate for changes in activation bias caused by quantization.`,name:"apply_bias_correction"},{anchor:"optimum.amd.BrevitasQuantizationConfig.apply_gptq",description:`<strong>apply_gptq</strong> (<code>bool</code>, defaults to <code>False</code>) &#x2014;
Whether to apply GPTQ algorithm for quantizing the weights.`,name:"apply_gptq"},{anchor:"optimum.amd.BrevitasQuantizationConfig.gptq_act_order",description:`<strong>gptq_act_order</strong> (<code>Optional[bool]</code>, defaults to <code>None</code>) &#x2014;
Whether to use activations reordering (act-order, also known as desc-act) when <code>apply_gptq=True</code>. If <code>apply_gptq=True</code>, defaults to <code>False</code>.`,name:"gptq_act_order"},{anchor:"optimum.amd.BrevitasQuantizationConfig.layers_to_exclude",description:`<strong>layers_to_exclude</strong> (<code>Optional[List]</code>, defaults to <code>None</code>) &#x2014;
Specify the names of the layers that should not be quantized. This should only be the last part of the layer name. If the same name is repeated across multiple layers, they will all be excluded.
If left to None, the last linear layer is automatically identified and excluded.`,name:"layers_to_exclude"}],source:"https://github.com/huggingface/optimum.amd/blob/vr_149/optimum/amd/brevitas/configuration.py#L8"}}),{c(){l=s("meta"),k=i(),P=s("p"),D=i(),w(g.$$.fragment),E=i(),w(_.$$.fragment),U=i(),a=s("div"),w(f.$$.fragment),J=i(),C=s("p"),C.textContent=ae,K=i(),m=s("div"),w(v.$$.fragment),X=i(),T=s("p"),T.textContent=ie,Y=i(),p=s("div"),w(z.$$.fragment),Z=i(),O=s("p"),O.innerHTML=ne,H=i(),w(q.$$.fragment),W=i(),u=s("div"),w(b.$$.fragment),ee=i(),N=s("p"),N.textContent=re,S=i(),I=s("p"),this.h()},l(e){const o=me("svelte-u9bgzb",document.head);l=d(o,"META",{name:!0,content:!0}),o.forEach(t),k=n(e),P=d(e,"P",{}),F(P).forEach(t),D=n(e),y(g.$$.fragment,e),E=n(e),y(_.$$.fragment,e),U=n(e),a=d(e,"DIV",{class:!0});var h=F(a);y(f.$$.fragment,h),J=n(h),C=d(h,"P",{"data-svelte-h":!0}),G(C)!=="svelte-1o9yf3m"&&(C.textContent=ae),K=n(h),m=d(h,"DIV",{class:!0});var M=F(m);y(v.$$.fragment,M),X=n(M),T=d(M,"P",{"data-svelte-h":!0}),G(T)!=="svelte-gebfsd"&&(T.textContent=ie),M.forEach(t),Y=n(h),p=d(h,"DIV",{class:!0});var R=F(p);y(z.$$.fragment,R),Z=n(R),O=d(R,"P",{"data-svelte-h":!0}),G(O)!=="svelte-1wnaegt"&&(O.innerHTML=ne),R.forEach(t),h.forEach(t),H=n(e),y(q.$$.fragment,e),W=n(e),u=d(e,"DIV",{class:!0});var V=F(u);y(b.$$.fragment,V),ee=n(V),N=d(V,"P",{"data-svelte-h":!0}),G(N)!=="svelte-1i7q6pw"&&(N.textContent=re),V.forEach(t),S=n(e),I=d(e,"P",{}),F(I).forEach(t),this.h()},h(){L(l,"name","hf:doc:metadata"),L(l,"content",he),L(m,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),L(p,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),L(a,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),L(u,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8")},m(e,o){r(document.head,l),c(e,k,o),c(e,P,o),c(e,D,o),x(g,e,o),c(e,E,o),x(_,e,o),c(e,U,o),c(e,a,o),x(f,a,null),r(a,J),r(a,C),r(a,K),r(a,m),x(v,m,null),r(m,X),r(m,T),r(a,Y),r(a,p),x(z,p,null),r(p,Z),r(p,O),c(e,H,o),x(q,e,o),c(e,W,o),c(e,u,o),x(b,u,null),r(u,ee),r(u,N),c(e,S,o),c(e,I,o),A=!0},p:de,i(e){A||($(g.$$.fragment,e),$(_.$$.fragment,e),$(f.$$.fragment,e),$(v.$$.fragment,e),$(z.$$.fragment,e),$(q.$$.fragment,e),$(b.$$.fragment,e),A=!0)},o(e){Q(g.$$.fragment,e),Q(_.$$.fragment,e),Q(f.$$.fragment,e),Q(v.$$.fragment,e),Q(z.$$.fragment,e),Q(q.$$.fragment,e),Q(b.$$.fragment,e),A=!1},d(e){e&&(t(k),t(P),t(D),t(E),t(U),t(a),t(H),t(W),t(u),t(S),t(I)),t(l),B(g,e),B(_,e),B(f),B(v),B(z),B(q,e),B(b)}}}const he='{"title":"Quantization Using Brevitas","local":"quantization-using-brevitas","sections":[{"title":"BrevitasQuantizer","local":"optimum.amd.BrevitasQuantizer","sections":[],"depth":2},{"title":"BrevitasQuantizationConfig","local":"optimum.amd.BrevitasQuantizationConfig","sections":[],"depth":2}],"depth":1}';function ge(oe){return ce(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class qe extends le{constructor(l){super(),ue(this,l,ge,pe,se,{})}}export{qe as component};
